package com.yeejoin.amos.iot.rxtx.reader;


import com.yeejoin.amos.iot.rxtx.SerialContext;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @author han xinjian
 **/
public class AnyDataReader implements SerialReader {

    SerialContext serialContext;

    private static byte[] buffer;

    public AnyDataReader(SerialContext serialContext) {
        this.serialContext = serialContext;
    }

    @Override
    public byte[] readBytes() {
        try {
            int length = serialContext.getSerialPort().getInputStream().available();
            if (length == 0) {
                return null;
            }

            byte[] dist = new byte[length];
            serialContext.getSerialPort().getInputStream().read(dist);

            if (dist[0] == 0 && dist[length - 1] == -2) {
                return filter(dist);
            } else if (dist[0] == 0 && dist[length - 1] != -2){
                buffer = dist;
                return null;
            } else if (dist[0] != 0 && dist[length - 1] != -2) {
                ByteBuffer tempBuffer = ByteBuffer.allocate(length + buffer.length);
                tempBuffer.put(buffer);
                tempBuffer.put(dist);
                buffer = Arrays.copyOf(tempBuffer.array(), tempBuffer.position());
                return null;
            } else if (dist[length - 1] == -2) {
                ByteBuffer tempBuffer = ByteBuffer.allocate(length + buffer.length);
                tempBuffer.put(buffer);
                tempBuffer.put(dist);

                return filter(Arrays.copyOf(tempBuffer.array(), tempBuffer.position()));
            }
            return null;
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    private byte[] filter(byte[] src) {
        List<Byte> list = new ArrayList<Byte>();
        for (byte b: src) {
            if (b != 0 && b != -2) {
                list.add(b);
            }
        }
        ByteBuffer byteBuffer = ByteBuffer.allocate(list.size());
        for (byte b: list) {
            byteBuffer.put(b);
        }
        return Arrays.copyOf(byteBuffer.array(), byteBuffer.position());
    }

}
