package com.yeejoin.amos.iot.rxtx.service;

import com.yeejoin.amos.iot.rxtx.RxTxUtil;
import org.apache.log4j.Logger;
import org.dom4j.DocumentException;
import org.springframework.stereotype.Service;
import org.springframework.util.ObjectUtils;

import java.io.UnsupportedEncodingException;
import java.util.Map;

@Service("iSerialFrameService")
public class SerialFrameServiceImpl implements ISerialFrameService {
    private static final Logger logger = Logger.getLogger(SerialFrameServiceImpl.class);
    @Override
    public void parseData(byte[] msg) {
        String str = null;
        try {
            str = new String(msg,  "utf-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        if (ObjectUtils.isEmpty(str)) {
            return;
        }


        for (String xml : str.split("<?xml version=\"1.0\" encoding=\"UTF-8\"?>")) {
            if (ObjectUtils.isEmpty(xml)) {
                continue;
            }
            StringBuffer sf = new StringBuffer();
            sf.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            sf.append(xml);
            logger.debug(sf.toString());
            switch (RxTxUtil.getType(sf.toString())) {
                case "Json":
                    parseJson(sf.toString());
                    break;
                case "xml":
                    parseXML(sf.toString());
                    break;
                case "Number":
                case "String":
                    parseString(sf.toString());
                    break;
                default:
                    logger.debug("unkown String type");
            }
        }

    }

    private void parseJson(String str) {
    }

    private void parseXML(String str) {
        try {
            Map<String, Object> map = RxTxUtil.xmlToMap(str, false);
            logger.debug("parseXML MAP is : " + map.toString());
            SerialDataQueue.getInstance().add((Map) map.get("data"));
        } catch (DocumentException e) {
            logger.debug("parseXML ERROR, ERROR string is : " + str);
            e.printStackTrace();
        }
    }

    private void parseString(String str) {
    }

}
